diff -urN ../VisualBoyAdvance-1.7.2/src/GBA.cpp ./src/GBA.cpp
--- ../VisualBoyAdvance-1.7.2/src/GBA.cpp	2004-05-13 23:37:59 +0900
+++ ./src/GBA.cpp	2006-08-25 23:13:38 +0900
@@ -3889,35 +4305,68 @@
         if(stopState)
           res &= 0x3080;
         if(res) {
-          if(intState) {
-            CPUInterrupt();         
-            intState = false;
-            if(holdState) {
+          if (intState)
+          {
+            if (!IRQTicks)
+            {
+              CPUInterrupt();
+              intState = false;
               holdState = false;
               stopState = false;
-            }       
-          } else {
-            if(!holdState) {
+              holdType = 0;
+            }
+          }
+          else
+          {
+            if (!holdState)
+            {
               intState = true;
-              cpuLoopTicks = 5;
-              cpuSavedTicks = 5;
-            } else {
-              CPUInterrupt();         
-              if(holdState) {
-                holdState = false;
-                stopState = false;
-              }
+              IRQTicks=7;
+              if (cpuNextEvent> IRQTicks)
+                cpuNextEvent = IRQTicks;
+            }
+            else
+            {
+              CPUInterrupt();
+              holdState = false;
+              stopState = false;
+              holdType = 0;
             }
           }
+
+          // Stops the SWI Ticks emulation if an IRQ is executed
+          //(to avoid problems with nested IRQ/SWI)
+          if (SWITicks)
+            SWITicks = 0;
         }
       }
-      
-      if(ticks <= 0)
+
+      if(remainingTicks > 0) {
+        if(remainingTicks > cpuNextEvent)
+          clockTicks = cpuNextEvent;
+        else
+          clockTicks = remainingTicks;
+        remainingTicks -= clockTicks;
+        if(remainingTicks < 0)
+          remainingTicks = 0;
+        goto updateLoop;
+      }
+
+      if (timerOnOffDelay)
+          applyTimer();
+
+      if(cpuNextEvent > ticks)
+        cpuNextEvent = ticks;
+
+      if(ticks <= 0 || cpuBreakLoop)
         break;
+
     }
   }
 }
 
+
+
 struct EmulatedSystem GBASystem = {
   // emuMain
   CPULoop,
@@ -3931,7 +4380,7 @@
   CPUWriteBatteryFile,
   // emuReadState
   CPUReadState,
-  // emuWriteState
+  // emuWriteState 
   CPUWriteState,
   // emuReadMemState
   CPUReadMemState,
diff -urN ../VisualBoyAdvance-1.7.2/src/GBA.h ./src/GBA.h
--- ../VisualBoyAdvance-1.7.2/src/GBA.h	2004-05-13 23:04:58 +0900
+++ ./src/GBA.h	2006-08-25 23:13:38 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -30,7 +30,8 @@
 #define SAVE_GAME_VERSION_6 6
 #define SAVE_GAME_VERSION_7 7
 #define SAVE_GAME_VERSION_8 8
-#define SAVE_GAME_VERSION  SAVE_GAME_VERSION_8
+#define SAVE_GAME_VERSION_9 9
+#define SAVE_GAME_VERSION  SAVE_GAME_VERSION_9
 
 typedef struct {
   u8 *address;
@@ -83,8 +84,17 @@
 extern int armMode;
 extern void (*cpuSaveGameFunc)(u32,u8);
 
-extern bool freezeWorkRAM[0x40000];
-extern bool freezeInternalRAM[0x8000];
+#ifdef BKPT_SUPPORT
+extern u8 freezeWorkRAM[0x40000];
+extern u8 freezeInternalRAM[0x8000];
+extern u8 freezeVRAM[0x18000];
+extern u8 freezeOAM[0x400];
+extern u8 freezePRAM[0x400];
+extern bool debugger_last;
+extern int  oldreg[17];
+extern char oldbuffer[10];
+#endif
+
 extern bool CPUReadGSASnapshot(const char *);
 extern bool CPUWriteGSASnapshot(const char *, const char *, const char *, const char *);
 extern bool CPUWriteBatteryFile(const char *);
@@ -100,7 +110,9 @@
 extern bool CPUWriteMemState(char *, int);
 extern bool CPUWriteState(const char *);
 extern int CPULoadRom(const char *);
+extern void doMirroring(bool);
 extern void CPUUpdateRegister(u32, u16);
+extern void applyTimer ();
 extern void CPUWriteHalfWord(u32, u16);
 extern void CPUWriteByte(u32, u8);
 extern void CPUInit(const char *,bool);
@@ -110,7 +122,8 @@
 extern bool CPUIsGBAImage(const char *);
 extern bool CPUIsZipFile(const char *);
 #ifdef PROFILING
-extern void cpuProfil(char *buffer, int, u32, int);
+#include "prof/prof.h"
+extern void cpuProfil(profile_segment *seg);
 extern void cpuEnableProfiling(int hz);
 #endif
 
diff -urN ../VisualBoyAdvance-1.7.2/src/GBAinline.h ./src/GBAinline.h
--- ../VisualBoyAdvance-1.7.2/src/GBAinline.h	2004-05-13 23:04:44 +0900
+++ ./src/GBAinline.h	2006-09-04 06:52:25 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -28,6 +28,21 @@
 extern bool cpuFlashEnabled;
 extern bool cpuEEPROMEnabled;
 extern bool cpuEEPROMSensorEnabled;
+extern bool cpuDmaHack;
+extern u32 cpuDmaLast;
+extern bool timer0On;
+extern int timer0Ticks;
+extern int timer0ClockReload;
+extern bool timer1On;
+extern int timer1Ticks;
+extern int timer1ClockReload;
+extern bool timer2On;
+extern int timer2Ticks;
+extern int timer2ClockReload;
+extern bool timer3On;
+extern int timer3Ticks;
+extern int timer3ClockReload;
+extern int cpuTotalTicks;
 
 #define CPUReadByteQuick(addr) \
   map[(addr)>>24].address[(addr) & map[(addr)>>24].mask]
@@ -38,7 +53,7 @@
 #define CPUReadMemoryQuick(addr) \
   READ32LE(((u32*)&map[(addr)>>24].address[(addr) & map[(addr)>>24].mask]))
 
-inline u32 CPUReadMemory(u32 address)
+static inline u32 CPUReadMemory(u32 address)
 {
 
 #ifdef DEV_VERSION
@@ -86,7 +101,15 @@
     value = READ32LE(((u32 *)&paletteRAM[address & 0x3fC]));
     break;
   case 6:
-    value = READ32LE(((u32 *)&vram[address & 0x1fffc]));
+    address = (address & 0x1fffc);
+    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
+    {
+        value = 0;
+        break;
+    }
+    if ((address & 0x18000) == 0x18000)
+      address &= 0x17fff;
+    value = READ32LE(((u32 *)&vram[address]));
     break;
   case 7:
     value = READ32LE(((u32 *)&oam[address & 0x3FC]));
@@ -116,18 +139,17 @@
           armNextPC - 4 : armNextPC - 2);
     }
 #endif
-    
-    //    if(ioMem[0x205] & 0x40) {
+
+    if(cpuDmaHack) {
+      value = cpuDmaLast;
+    } else {
       if(armState) {
         value = CPUReadMemoryQuick(reg[15].I);
       } else {
         value = CPUReadHalfWordQuick(reg[15].I) |
           CPUReadHalfWordQuick(reg[15].I) << 16;
       }
-      //  } else {
-      //      value = *((u32 *)&bios[address & 0x3ffc]);
-      //    }
-      //        return 0xFFFFFFFF;
+    }
   }
 
   if(address & 3) {
@@ -156,7 +178,7 @@
 
 extern u32 myROM[];
 
-inline u32 CPUReadHalfWord(u32 address)
+static inline u32 CPUReadHalfWord(u32 address)
 {
 #ifdef DEV_VERSION      
   if(address & 1) {
@@ -192,14 +214,38 @@
     break;
   case 4:
     if((address < 0x4000400) && ioReadable[address & 0x3fe])
+    {
       value =  READ16LE(((u16 *)&ioMem[address & 0x3fe]));
+      if (((address & 0x3fe)>0xFF) && ((address & 0x3fe)<0x10E))
+      {
+        if (((address & 0x3fe) == 0x100) && timer0On)
+          value = 0xFFFF - ((timer0Ticks-cpuTotalTicks) >> timer0ClockReload);
+        else
+        if (((address & 0x3fe) == 0x104) && timer1On && !(TM1CNT & 4))
+          value = 0xFFFF - ((timer1Ticks-cpuTotalTicks) >> timer1ClockReload);
+        else
+        if (((address & 0x3fe) == 0x108) && timer2On && !(TM2CNT & 4))
+          value = 0xFFFF - ((timer2Ticks-cpuTotalTicks) >> timer2ClockReload);
+        else
+        if (((address & 0x3fe) == 0x10C) && timer3On && !(TM3CNT & 4))
+          value = 0xFFFF - ((timer3Ticks-cpuTotalTicks) >> timer3ClockReload);
+      }
+    }
     else goto unreadable;
     break;
   case 5:
     value = READ16LE(((u16 *)&paletteRAM[address & 0x3fe]));
     break;
   case 6:
-    value = READ16LE(((u16 *)&vram[address & 0x1fffe]));
+    address = (address & 0x1fffe);
+    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
+    {
+        value = 0;
+        break;
+    }
+    if ((address & 0x18000) == 0x18000)
+      address &= 0x17fff;
+    value = READ16LE(((u16 *)&vram[address]));
     break;
   case 7:
     value = READ16LE(((u16 *)&oam[address & 0x3fe]));
@@ -232,11 +278,8 @@
           armNextPC - 4 : armNextPC - 2);
     }
 #endif
-    extern bool cpuDmaHack;
-    extern u32 cpuDmaLast;
-    extern int cpuDmaCount;
-    if(cpuDmaHack && cpuDmaCount) {
-      value = (u16)cpuDmaLast;
+    if(cpuDmaHack) {
+      value = cpuDmaLast & 0xFFFF;
     } else {
       if(armState) {
         value = CPUReadHalfWordQuick(reg[15].I + (address & 2));
@@ -244,10 +287,6 @@
         value = CPUReadHalfWordQuick(reg[15].I);
       }
     }
-    //    return value;
-    //    if(address & 1)
-    //      value = (value >> 8) | ((value & 0xFF) << 24);
-    //    return 0xFFFF;
     break;
   }
 
@@ -258,7 +297,7 @@
   return value;
 }
 
-inline u16 CPUReadHalfWordSigned(u32 address)
+static inline u16 CPUReadHalfWordSigned(u32 address)
 {
   u16 value = CPUReadHalfWord(address);
   if((address & 1))
@@ -266,7 +305,7 @@
   return value;
 }
 
-inline u8 CPUReadByte(u32 address)
+static inline u8 CPUReadByte(u32 address)
 {
   switch(address >> 24) {
   case 0:
@@ -293,7 +332,12 @@
   case 5:
     return paletteRAM[address & 0x3ff];
   case 6:
-    return vram[address & 0x1ffff];
+    address = (address & 0x1ffff);
+    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
+        return 0;
+    if ((address & 0x18000) == 0x18000)
+      address &= 0x17fff;
+    return vram[address];
   case 7:
     return oam[address & 0x3ff];
   case 8:
@@ -325,28 +369,31 @@
   default:
   unreadable:
 #ifdef DEV_VERSION
-        if(systemVerbose & VERBOSE_ILLEGAL_READ) {
-          log("Illegal byte read: %08x at %08x\n", address, armMode ?
-              armNextPC - 4 : armNextPC - 2);
-        }
+    if(systemVerbose & VERBOSE_ILLEGAL_READ) {
+      log("Illegal byte read: %08x at %08x\n", address, armMode ?
+          armNextPC - 4 : armNextPC - 2);
+    }
 #endif
-    
-    if(armState) {
-      return CPUReadByteQuick(reg[15].I+(address & 3));
+    if(cpuDmaHack) {
+      return cpuDmaLast & 0xFF;
     } else {
-      return CPUReadByteQuick(reg[15].I+(address & 1));
+      if(armState) {
+        return CPUReadByteQuick(reg[15].I+(address & 3));
+      } else {
+        return CPUReadByteQuick(reg[15].I+(address & 1));
+      }
     }
-    //    return 0xFF;
     break;
   }
 }
 
-inline void CPUWriteMemory(u32 address, u32 value)
+static inline void CPUWriteMemory(u32 address, u32 value)
 {
+
 #ifdef DEV_VERSION
   if(address & 3) {
     if(systemVerbose & VERBOSE_UNALIGNED_MEMORY) {
-      log("Unaliagned word write: %08x to %08x from %08x\n",
+      log("Unaligned word write: %08x to %08x from %08x\n",
           value,
           address,
           armMode ? armNextPC - 4 : armNextPC - 2);
@@ -356,39 +403,60 @@
   
   switch(address >> 24) {
   case 0x02:
-#ifdef SDL
+#ifdef BKPT_SUPPORT
     if(*((u32 *)&freezeWorkRAM[address & 0x3FFFC]))
-      cheatsWriteMemory((u32 *)&workRAM[address & 0x3FFFC],
-                        value,
-                        *((u32 *)&freezeWorkRAM[address & 0x3FFFC]));
+      cheatsWriteMemory(address & 0x203FFFC,
+                        value);
     else
 #endif
       WRITE32LE(((u32 *)&workRAM[address & 0x3FFFC]), value);
     break;
   case 0x03:
-#ifdef SDL
+#ifdef BKPT_SUPPORT
     if(*((u32 *)&freezeInternalRAM[address & 0x7ffc]))
-      cheatsWriteMemory((u32 *)&internalRAM[address & 0x7FFC],
-                        value,
-                        *((u32 *)&freezeInternalRAM[address & 0x7ffc]));
+      cheatsWriteMemory(address & 0x3007FFC,
+                        value);
     else
 #endif
       WRITE32LE(((u32 *)&internalRAM[address & 0x7ffC]), value);
     break;
   case 0x04:
-    CPUUpdateRegister((address & 0x3FC), value & 0xFFFF);
-    CPUUpdateRegister((address & 0x3FC) + 2, (value >> 16));
+    if(address < 0x4000400) {
+      CPUUpdateRegister((address & 0x3FC), value & 0xFFFF);
+      CPUUpdateRegister((address & 0x3FC) + 2, (value >> 16));
+    } else goto unwritable;
     break;
   case 0x05:
+#ifdef BKPT_SUPPORT
+    if(*((u32 *)&freezePRAM[address & 0x3fc]))
+      cheatsWriteMemory(address & 0x70003FC,
+                        value);
+    else
+#endif
     WRITE32LE(((u32 *)&paletteRAM[address & 0x3FC]), value);
     break;
   case 0x06:
-    if(address & 0x10000)
-      WRITE32LE(((u32 *)&vram[address & 0x17ffc]), value);
+    address = (address & 0x1fffc);
+    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
+        return;
+    if ((address & 0x18000) == 0x18000)
+      address &= 0x17fff;
+
+#ifdef BKPT_SUPPORT
+    if(*((u32 *)&freezeVRAM[address]))
+      cheatsWriteMemory(address + 0x06000000, value);
     else
-      WRITE32LE(((u32 *)&vram[address & 0x1fffc]), value);
+#endif
+    
+    WRITE32LE(((u32 *)&vram[address]), value);
     break;
   case 0x07:
+#ifdef BKPT_SUPPORT
+    if(*((u32 *)&freezeOAM[address & 0x3fc]))
+      cheatsWriteMemory(address & 0x70003FC,
+                        value);
+    else
+#endif
     WRITE32LE(((u32 *)&oam[address & 0x3fc]), value);
     break;
   case 0x0D:
diff -urN ../VisualBoyAdvance-1.7.2/src/Gfx.cpp ./src/Gfx.cpp
--- ../VisualBoyAdvance-1.7.2/src/Gfx.cpp	2004-05-13 23:37:47 +0900
+++ ./src/Gfx.cpp	2005-09-03 21:28:23 +0900
@@ -22,7 +22,6 @@
   0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
   16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16};
 
-
 u32 line0[240];
 u32 line1[240];
 u32 line2[240];
@@ -32,6 +31,7 @@
 u32 lineMix[240];
 bool gfxInWin0[240];
 bool gfxInWin1[240];
+int lineOBJpixleft[128];
 
 int gfxBG2Changed = 0;
 int gfxBG3Changed = 0;
diff -urN ../VisualBoyAdvance-1.7.2/src/Gfx.h ./src/Gfx.h
--- ../VisualBoyAdvance-1.7.2/src/Gfx.h	2004-05-13 23:04:18 +0900
+++ ./src/Gfx.h	2006-08-25 23:50:53 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -100,6 +100,7 @@
 extern u32 lineMix[240];
 extern bool gfxInWin0[240];
 extern bool gfxInWin1[240];
+extern int lineOBJpixleft[128];
 
 extern int gfxBG2Changed;
 extern int gfxBG3Changed;
@@ -305,7 +306,7 @@
   int dy = pc & 0x7FFF;
   if(pc & 0x8000)
     dy |= 0xFFFF8000;
-  int dmy = pd & 0x7FFFF;
+  int dmy = pd & 0x7FFF;
   if(pd & 0x8000)
     dmy |= 0xFFFF8000;
 
@@ -462,7 +463,7 @@
   int dy = pc & 0x7FFF;
   if(pc & 0x8000)
     dy |= 0xFFFF8000;
-  int dmy = pd & 0x7FFFF;
+  int dmy = pd & 0x7FFF;
   if(pd & 0x8000)
     dmy |= 0xFFFF8000;
 
@@ -560,7 +561,7 @@
   int dy = pc & 0x7FFF;
   if(pc & 0x8000)
     dy |= 0xFFFF8000;
-  int dmy = pd & 0x7FFFF;
+  int dmy = pd & 0x7FFF;
   if(pd & 0x8000)
     dmy |= 0xFFFF8000;
 
@@ -661,7 +662,7 @@
   int dy = pc & 0x7FFF;
   if(pc & 0x8000)
     dy |= 0xFFFF8000;
-  int dmy = pd & 0x7FFFF;
+  int dmy = pd & 0x7FFF;
   if(pd & 0x8000)
     dmy |= 0xFFFF8000;
 
@@ -731,6 +732,10 @@
 
 inline void gfxDrawSprites(u32 *lineOBJ)
 {
+  // lineOBJpix is used to keep track of the drawn OBJs
+  // and to stop drawing them if the 'maximum number of OBJ per line'
+  // has been reached.
+  int lineOBJpix = (DISPCNT & 0x20) ? 954 : 1226;
   int m=0;
   gfxClearArray(lineOBJ);
   if(layerEnable & 0x1000) {
@@ -744,55 +749,37 @@
       u16 a2 = READ16LE(sprites++);
       sprites++;
 
-      // ignore OBJ-WIN
-      if((a0 & 0x0c00) == 0x0800)
-         continue;
-      
-      int sizeY = 8;
-      int sizeX = 8;
-      
-      switch(((a0 >>12) & 0x0c)|(a1>>14)) {
-      case 0:
-        break;
-      case 1:
-        sizeX = sizeY = 16;
-        break;
-      case 2:
-        sizeX = sizeY = 32;
-        break;
-      case 3:
-        sizeX = sizeY = 64;
-        break;
-      case 4:
-        sizeX = 16;
-        break;
-      case 5:
-        sizeX = 32;
-        break;
-      case 6:
-        sizeX = 32;
-        sizeY = 16;
-        break;
-      case 7:
-        sizeX = 64;
-        sizeY = 32;
-        break;
-      case 8:
-        sizeY = 16;
-        break;
-      case 9:
-        sizeY = 32;
-        break;
-      case 10:
-        sizeX = 16;
-        sizeY = 32;
-        break;
-      case 11:
-        sizeX = 32;
-        sizeY = 64;
-        break;
-      default:
+      lineOBJpixleft[x]=lineOBJpix;
+
+      lineOBJpix-=2;
+      if (lineOBJpix<=0)
         continue;
+
+      if ((a0 & 0x0c00) == 0x0c00)
+        a0 &=0xF3FF;
+
+      if ((a0>>14) == 3)
+      {
+        a0 &= 0x3FFF;
+        a1 &= 0x3FFF;
+      }
+      
+      int sizeX = 8<<(a1>>14);
+      int sizeY = sizeX;
+
+      if ((a0>>14) & 1)
+      {
+        if (sizeX<32)
+          sizeX<<=1;
+        if (sizeY>8)
+          sizeY>>=1;
+      }
+      else if ((a0>>14) & 2)
+      {
+        if (sizeX>8)
+          sizeX>>=1;
+        if (sizeY<32)
+          sizeY<<=1;
       }
 
 #ifdef SPRITE_DEBUG
@@ -801,9 +788,45 @@
 #endif
 
       int sy = (a0 & 255);
+      int sx = (a1 & 0x1FF);
+
+      // computes ticks used by OBJ-WIN if OBJWIN is enabled
+      if (((a0 & 0x0c00) == 0x0800) && (layerEnable & 0x8000))
+      {
+        if ((a0 & 0x0300) == 0x0300)
+        {
+          sizeX<<=1;
+          sizeY<<=1;
+        }
+        if((sy+sizeY) > 256)
+          sy -= 256;
+        if ((sx+sizeX)> 512)
+          sx-=512;
+        if (sx<0)
+        {
+            sizeX+=sx;
+            sx = 0;
+        }
+        else if ((sx+sizeX)>240)
+            sizeX=240-sx;
+        if ((VCOUNT>=sy) && (VCOUNT<sy+sizeY) && (sx<240))
+        {
+          if (a0 & 0x0100)
+            lineOBJpix-=8+2*sizeX;
+          else
+            lineOBJpix-=sizeX-2;
+        }
+        continue;
+      }
+      // else ignores OBJ-WIN if OBJWIN is disabled, and ignored disabled OBJ
+      else
+      if(((a0 & 0x0c00) == 0x0800) || ((a0 & 0x0300) == 0x0200))
+        continue;
+
+      if (lineOBJpix<0)
+        continue;
+
 
-      if(sy > 160)
-        sy -= 256;
       
       if(a0 & 0x0100) {
         int fieldX = sizeX;
@@ -812,11 +835,18 @@
           fieldX <<= 1;
           fieldY <<= 1;
         }
-        
+        if((sy+fieldY) > 256)
+          sy -= 256;
         int t = VCOUNT - sy;
         if((t >= 0) && (t < fieldY)) {
-          int sx = (a1 & 0x1FF);
-          if((sx < 240) || (((sx + fieldX) & 511) < 240)) {
+          int startpix = 0;
+          if ((sx+fieldX)> 512)
+          {
+            startpix=512-sx;
+          }
+          if (lineOBJpix>0)
+          if((sx < 240) || startpix) {
+            lineOBJpix-=8; 
             // int t2 = t - (fieldY >> 1);
             int rot = (a1 >> 9) & 0x1F;
             u16 *OAM = (u16 *)oam;
@@ -854,6 +884,10 @@
               else
                 c &= 0x3FE;
               for(int x = 0; x < fieldX; x++) {
+                if (x >= startpix)
+                  lineOBJpix-=2;
+                if (lineOBJpix<0)
+                  continue;
                 int xxx = realX >> 8;
                 int yyy = realY >> 8;
                 
@@ -885,7 +919,7 @@
                     lineOBJ[sx] = 0x001F;
 #endif
                 }
-                sx = (sx+1)&511;;
+                sx = (sx+1)&511;
                 realX += dx;
                 realY += dy;
               }
@@ -897,8 +931,12 @@
               int inc = 32;
               if(DISPCNT & 0x40)
                 inc = sizeX >> 3;
-              int palette = (a2 >> 8) & 0xF0;                 
+              int palette = (a2 >> 8) & 0xF0;
               for(int x = 0; x < fieldX; x++) {
+                if (x >= startpix)
+                  lineOBJpix-=2;
+                if (lineOBJpix<0)
+                  continue;
                 int xxx = realX >> 8;
                 int yyy = realY >> 8;
                 if(xxx < 0 || xxx >= sizeX ||
@@ -934,7 +972,7 @@
                   if(t == 0 || t == maskY || x == 0 || x == maskX)
                     lineOBJ[sx] = 0x001F;
 #endif
-                sx = (sx+1)&511;;
+                sx = (sx+1)&511;
                 realX += dx;
                 realY += dy;
                 
@@ -943,10 +981,17 @@
           }
         }
       } else {
+        if(sy+sizeY > 256)
+          sy -= 256;
         int t = VCOUNT - sy;
         if((t >= 0) && (t < sizeY)) {
-          int sx = (a1 & 0x1FF);
-          if(((sx < 240)||(((sx+sizeX)&511)<240)) && !(a0 & 0x0200)) {
+          int startpix = 0;
+          if ((sx+sizeX)> 512)
+          {
+            startpix=512-sx;
+          }
+          if((sx < 240) || startpix) {
+            lineOBJpix+=2;
             if(a0 & 0x2000) {
               if(a1 & 0x2000)
                 t = sizeY - t - 1;
@@ -976,6 +1021,10 @@
               u32 prio = (((a2 >> 10) & 3) << 25) | ((a0 & 0x0c00)<<6);
                 
               for(int xx = 0; xx < sizeX; xx++) {
+                if (xx >= startpix)
+                  lineOBJpix--;
+                if (lineOBJpix<0)
+                  continue;
                 if(sx < 240) {
                   u8 color = vram[address];
                   if ((color==0) && (((prio >> 25)&3) < 
@@ -1048,6 +1097,10 @@
               if(a1 & 0x1000) {
                 xxx = 7;
                 for(int xx = sizeX - 1; xx >= 0; xx--) {
+                  if (xx >= startpix)
+                    lineOBJpix--;
+                  if (lineOBJpix<0)
+                    continue;
                   if(sx < 240) {
                     u8 color = vram[address];
                     if(xx & 1) {
@@ -1088,6 +1141,10 @@
                 }           
               } else {        
                 for(int xx = 0; xx < sizeX; xx++) {
+                  if (xx >= startpix)
+                    lineOBJpix--;
+                  if (lineOBJpix<0)
+                    continue;
                   if(sx < 240) {
                     u8 color = vram[address];
                     if(xx & 1) {
@@ -1139,70 +1196,51 @@
 inline void gfxDrawOBJWin(u32 *lineOBJWin)
 {
   gfxClearArray(lineOBJWin);
-  if(layerEnable & 0x8000) {
+  if((layerEnable & 0x9000) == 0x9000) {
     u16 *sprites = (u16 *)oam;
     // u16 *spritePalette = &((u16 *)paletteRAM)[256];
     for(int x = 0; x < 128 ; x++) {
+      int lineOBJpix = lineOBJpixleft[x];
       u16 a0 = READ16LE(sprites++);
       u16 a1 = READ16LE(sprites++);
       u16 a2 = READ16LE(sprites++);
       sprites++;
 
-      // ignore non OBJ-WIN
-      if((a0 & 0x0c00) != 0x0800)
+      if (lineOBJpix<=0)
         continue;
+
+      // ignores non OBJ-WIN and disabled OBJ-WIN
+      if(((a0 & 0x0c00) != 0x0800) || ((a0 & 0x0300) == 0x0200))
+        continue;
+
+      if ((a0 & 0x0c00) == 0x0c00)
+        a0 &=0xF3FF;
       
-      int sizeY = 8;
-      int sizeX = 8;
+      if ((a0>>14) == 3)
+      {
+        a0 &= 0x3FFF;
+        a1 &= 0x3FFF;
+      }
       
-      switch(((a0 >>12) & 0x0c)|(a1>>14)) {
-      case 0:
-        break;
-      case 1:
-        sizeX = sizeY = 16;
-        break;
-      case 2:
-        sizeX = sizeY = 32;
-        break;
-      case 3:
-        sizeX = sizeY = 64;
-        break;
-      case 4:
-        sizeX = 16;
-        break;
-      case 5:
-        sizeX = 32;
-        break;
-      case 6:
-        sizeX = 32;
-        sizeY = 16;
-        break;
-      case 7:
-        sizeX = 64;
-        sizeY = 32;
-        break;
-      case 8:
-        sizeY = 16;
-        break;
-      case 9:
-        sizeY = 32;
-        break;
-      case 10:
-        sizeX = 16;
-        sizeY = 32;
-        break;
-      case 11:
-        sizeX = 32;
-        sizeY = 64;
-        break;
-      default:
-        continue;
+      int sizeX = 8<<(a1>>14);
+      int sizeY = sizeX;
+
+      if ((a0>>14) & 1)
+      {
+        if (sizeX<32)
+          sizeX<<=1;
+        if (sizeY>8)
+          sizeY>>=1;
+      }
+      else if ((a0>>14) & 2)
+      {
+        if (sizeX>8)
+          sizeX>>=1;
+        if (sizeY<32)
+          sizeY<<=1;
       }
 
       int sy = (a0 & 255);
-
-      if(sy > 160)
-        sy -= 256;
       
       if(a0 & 0x0100) {
         int fieldX = sizeX;
@@ -1211,11 +1249,18 @@
           fieldX <<= 1;
           fieldY <<= 1;
         }
-        
+        if((sy+fieldY) > 256)
+          sy -= 256;
         int t = VCOUNT - sy;
         if((t >= 0) && (t < fieldY)) {
           int sx = (a1 & 0x1FF);
-          if((sx < 240) || (((sx + fieldX) & 511) < 240)) {
+          int startpix = 0;
+          if ((sx+fieldX)> 512)
+          {
+            startpix=512-sx;
+          }
+          if((sx < 240) || startpix) {
+            lineOBJpix-=8;
             // int t2 = t - (fieldY >> 1);
             int rot = (a1 >> 9) & 0x1F;
             u16 *OAM = (u16 *)oam;
@@ -1249,11 +1294,16 @@
               else
                 c &= 0x3FE;
               for(int x = 0; x < fieldX; x++) {
+                if (x >= startpix)
+                  lineOBJpix-=2;
+                if (lineOBJpix<0)
+                  continue;
                 int xxx = realX >> 8;
                 int yyy = realY >> 8;
                 
                 if(xxx < 0 || xxx >= sizeX ||
-                   yyy < 0 || yyy >= sizeY) {
+                   yyy < 0 || yyy >= sizeY ||
+                   sx >= 240) {
                 } else {
                   u32 color = vram[0x10000 + ((((c + (yyy>>3) * inc)<<5)
                                     + ((yyy & 7)<<3) + ((xxx >> 3)<<6) +
@@ -1262,7 +1312,7 @@
                     lineOBJWin[sx] = 1;
                   }
                 }
-                sx = (sx+1)&511;;
+                sx = (sx+1)&511;
                 realX += dx;
                 realY += dy;
               }
@@ -1276,6 +1326,10 @@
                 inc = sizeX >> 3;
               // int palette = (a2 >> 8) & 0xF0;                      
               for(int x = 0; x < fieldX; x++) {
+                if (x >= startpix)
+                  lineOBJpix-=2;
+                if (lineOBJpix<0)
+                  continue;
                 int xxx = realX >> 8;
                 int yyy = realY >> 8;
 
@@ -1284,7 +1338,8 @@
                 //                lineOBJ[sx] = 0x001F | prio;
                 //              } else {
                   if(xxx < 0 || xxx >= sizeX ||
-                     yyy < 0 || yyy >= sizeY){
+                     yyy < 0 || yyy >= sizeY ||
+                     sx >= 240) {
                   } else {
                     u32 color = vram[0x10000 + ((((c + (yyy>>3) * inc)<<5)
                                      + ((yyy & 7)<<2) + ((xxx >> 3)<<5) +
@@ -1299,7 +1354,7 @@
                     }
                   }
                   //            }
-                sx = (sx+1)&511;;
+                sx = (sx+1)&511;
                 realX += dx;
                 realY += dy;
               }       
@@ -1307,10 +1362,18 @@
           }
         }
       } else {
+        if((sy+sizeY) > 256)
+          sy -= 256;
         int t = VCOUNT - sy;
         if((t >= 0) && (t < sizeY)) {
           int sx = (a1 & 0x1FF);
-          if(((sx < 240)||(((sx+sizeX)&511)<240)) && !(a0 & 0x0200)) {
+          int startpix = 0;
+          if ((sx+sizeX)> 512)
+          {
+            startpix=512-sx;
+          }
+          if((sx < 240) || startpix) {
+            lineOBJpix+=2;
             if(a0 & 0x2000) {
               if(a1 & 0x2000)
                 t = sizeY - t - 1;
@@ -1333,6 +1396,10 @@
                 xxx = 7;
               // u32 prio = (((a2 >> 10) & 3) << 25) | ((a0 & 0x0c00)<<6);
               for(int xx = 0; xx < sizeX; xx++) {
+                if (xx >= startpix)
+                  lineOBJpix--;
+                if (lineOBJpix<0)
+                  continue;
                 if(sx < 240) {
                   u8 color = vram[address];
                   if(color) {
@@ -1382,6 +1449,10 @@
               if(a1 & 0x1000) {
                 xxx = 7;
                 for(int xx = sizeX - 1; xx >= 0; xx--) {
+                  if (xx >= startpix)
+                    lineOBJpix--;
+                  if (lineOBJpix<0)
+                    continue;
                   if(sx < 240) {
                     u8 color = vram[address];
                     if(xx & 1) {
@@ -1406,6 +1477,10 @@
                 }           
               } else {        
                 for(int xx = 0; xx < sizeX; xx++) {
+                  if (xx >= startpix)
+                    lineOBJpix--;
+                  if (lineOBJpix<0)
+                    continue;
                   if(sx < 240) {
                     u8 color = vram[address];
                     if(xx & 1) {
@@ -1528,10 +1603,10 @@
     int g0 = ((color2 >> 5) & 0x1F);
     int b0 = ((color2 >> 10) & 0x1F);
     
-    r = ((r * ca) >> 4) + ((r0 * cb) >> 4);
-    g = ((g * ca) >> 4) + ((g0 * cb) >> 4);
-    b = ((b * ca) >> 4) + ((b0 * cb) >> 4);
-    
+    r = ((r * ca) + (r0 * cb)) >> 4;
+    g = ((g * ca) + (g0 * cb)) >> 4;
+    b = ((b * ca) + (b0 * cb)) >> 4;
+
     if(r > 31)
       r = 31;
     if(g > 31)
@@ -1557,9 +1632,9 @@
       int g0 = ((color2 >> 5) & 0x1F);
       int b0 = ((color2 >> 10) & 0x1F);
       
-      r = ((r * ca) >> 4) + ((r0 * cb) >> 4);
-      g = ((g * ca) >> 4) + ((g0 * cb) >> 4);
-      b = ((b * ca) >> 4) + ((b0 * cb) >> 4);
+      r = ((r * ca) + (r0 * cb)) >> 4;
+      g = ((g * ca) + (g0 * cb)) >> 4;
+      b = ((b * ca) + (b0 * cb)) >> 4;
       
       if(r > 31)
         r = 31;
diff -urN ../VisualBoyAdvance-1.7.2/src/Globals.cpp ./src/Globals.cpp
--- ../VisualBoyAdvance-1.7.2/src/Globals.cpp	2004-05-13 23:37:29 +0900
+++ ./src/Globals.cpp	2006-08-01 00:51:01 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -18,6 +18,11 @@
 
 #include "GBA.h"
 
+#ifdef BKPT_SUPPORT
+int  oldreg[17];
+char oldbuffer[10];
+#endif
+
 reg_pair reg[45];
 memoryMap map[256];
 bool ioReadable[0x400];
@@ -43,8 +48,8 @@
 int layerEnable = 0xff00;
 bool speedHack = false;
 int cpuSaveType = 0;
-bool cpuEnhancedDetection = true;
 bool cheatsEnabled = true;
+bool mirroringEnable = false;
 
 u8 *bios = NULL;
 u8 *rom = NULL;
